<template>
  <div class='AuthForm' >
    <div class="AuthForm-title">
      <span v-lang.logIn />
      <span v-if="signInAs === 'teacher'" v-lang.teacher />
      <span v-if="signInAs === 'student'" v-lang.student />
    </div>
    <form class="AuthForm-form" @submit.prevent="formValid">
      <div class="login-field">
        <label for="user-login"><span v-lang.loginTitle />:</label>
        <input :class="empty.email ? 'error-input' : ''" type="text" id="user-login" :placeholder="loginPlaceholder()" v-model="form.email">
        <transition name="fade">
          <span class="error" v-if="empty.email"><md-icon>clear</md-icon></span>
        </transition>
      </div>
      <div class="password-field">
        <label for="user-password"><span v-lang.password />:</label>
        <input :class="empty.password ? 'error-input' : ''" type="password" id="user-password" :placeholder="passPlaceholder()" v-model="form.password">
        <transition name="fade">
          <span class="error" v-if="empty.password"><md-icon>clear</md-icon></span>
        </transition>
      </div>
      <div class="remember-check">
        <input type="checkbox" id="remember-me" name="remember-me" v-model="form.remember">
        <label for="remember-me"><span v-lang.remember />:
          <transition name="fade">
            <md-icon v-if="form.remember">done</md-icon>
          </transition>
        </label>
      </div>
      <button type="submit" v-lang.loginTitle />
    </form>
  </div>
</template>

<script>

import { mapActions, mapGetters } from 'vuex';
import valid from '../../utils/validator';

export default {
  props: {
    signInAs: { type: String }
  },
  components: {},
  data () {
    return {
      form: {
        email: '',
        password: '',
        remember: false,
        instance: this.signInAs
      },
    }
  },
  methods: {
    ...mapActions({
      logIn: 'logIn'
    }),
    loginPlaceholder() {
      return this.translate('loginPlaceholder');
    },
    passPlaceholder() {
      return this.translate('password');
    },
    formValid() {
      if (valid(this.form).isValid) {
        this.logIn(this.form);
      }
    },
  },
  computed: {
    ...mapGetters({
      empty: 'getEmptyFields',
    }),
  },
  updated() {
    valid(this.form);
  }
}
</script>

<style scoped lang='scss' rel="stylesheet/scss">
@import "AuthForm";
</style>
